import { ParseTree, TokenStream } from 'antlr4ng';
import * as c3 from 'antlr4-c3';
import { AutocompleteResultBase } from '../../shared/autocomplete-types.js';
import { MongoAutocompleteResult } from './index.js';
import { MongoParser } from './generated/MongoParser.js';
import { MongoLexer } from './generated/MongoLexer.js';
export declare function getParseTree(parser: MongoParser): ParseTree;
declare function enrichAutocompleteResult(baseResult: AutocompleteResultBase, rules: c3.CandidatesCollection['rules'], _tokenStream: TokenStream, cursorTokenIndex: number): MongoAutocompleteResult;
export declare const mongoAutocompleteData: {
    Lexer: typeof MongoLexer;
    Parser: typeof MongoParser;
    tokenDictionary: {
        SPACE: number;
        SEMICOLON: number;
    };
    ignoredTokens: Set<number>;
    rulesToVisit: Set<number>;
    getParseTree: typeof getParseTree;
    enrichAutocompleteResult: typeof enrichAutocompleteResult;
};
export {};
