import { ConstraintSuggestion, CursorPosition, SqlAutocompleteResult, TableOrViewSuggestion } from '../../shared/autocomplete-types';
import { ExtractStatementPositionsResult } from '../../shared/extract-statement-positions-from-query';
export interface MySqlAutocompleteResult extends SqlAutocompleteResult {
    suggestViewsOrTables?: TableOrViewSuggestion;
    suggestIndexes?: boolean;
    suggestTriggers?: boolean;
    suggestConstraints?: ConstraintSuggestion;
    suggestRoles?: boolean;
    suggestUsers?: boolean;
}
export declare function parseMySqlQueryWithoutCursor(query: string): Pick<MySqlAutocompleteResult, 'errors'>;
export declare function parseMySqlQuery(query: string, cursor: CursorPosition): MySqlAutocompleteResult;
export declare function parseMySqlQueryWithCursor(queryWithCursor: string): MySqlAutocompleteResult;
export declare function extractMySqlStatementPositionsFromQuery(query: string): ExtractStatementPositionsResult;
